/**
 * Created by Heraldo on 28.06.2015.
 */
public class Person {
    private final String name;
    private final float height;
    private final float weight;
    private Dog pet;

    public Person(String name) {
        this.name = name;
        height = (float)Math.random() * 100f + 100f;
        weight = (float)Math.random() * 60f + 20f;
    }

    public Person(String name, Dog pet) {
        this(name);
        setPet(pet);
    }

    public Person(Person other) { //tiefe Kopie
        this(other.name, other.height, other.weight);

        if(other.pet != null) {
            Dog p = other.pet;
            this.pet = new Dog(p.getName(), p.getHeight(), p.getWeight());
        }

        if(this.pet != null)
            this.pet.setOwner(this);
    }

    public Person(String n, float h, float w) { // Hilfskonstruktor fuer eine tiefe Kopie
        name = n;
        height = h;
        weight = w;
    }

    public float getHeight() {
        return height;
    }

    public float getWeight() {
        return weight;
    }

    public Dog getPet() {
        return pet;
    }

    public String getName() { return name; }

    public void setPet(Dog pet) { this.pet = pet;}

    public boolean isTallerThan(Person other) {
        return this.height > other.height;
    }

    @Override
    public String toString() {
        String out = pet != null? pet.getName() : "none";
        return String.format("Person called %s, %.2f tall, %.2f heavy and pet %s.\n", name, height, weight, out);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;

        if (o instanceof Person) {

            Person person = (Person) o;

            boolean check = name.equals(person.name) && height == person.height && weight == person.weight;

            if(pet != null)
                return checkPets(person.pet) && check;

            return person.pet != null? false : check;
        }

        return false;
    }

    private boolean checkPets(Dog p) { // verhindert endlose Rekursion bzw. StackOverflow
        return pet.getName().equals(pet.getName()) && pet.getHeight() == p.getHeight()
                && pet.getWeight() == p.getWeight();
    }
}
