import java.util.Iterator;

/**
 * Created by Heraldo on 28.06.2015.
 */
public class SortedList {
    private SortedList next;
    private Person value;

    public SortedList(){}

    public boolean isEmpty() {
        return value == null;
    }

    public void add(Person value) {
        if(value == null)
            throw new IllegalArgumentException("Person to be added is null.");

        if(isEmpty()) {
            this.value = value;
        }
        else {
            if (this.value.isTallerThan(value)) {
                Person p = this.value;
                this.value = value;
                value = p;
            }

            if (this.next == null)
                this.next = new SortedList();

            this.next.add(value);
        }
    }

    public int size() {
        return this.next != null? this.next.size() + 1 : 1;
    }

    public Person get(int index) {
        if(index < 0)
            throw new IllegalArgumentException("Wrong index argument.");

        if(index == 0)
            return this.value;

        if(this.next != null)
            return this.next.get(index - 1);

        return null;
    }

    public Iterator<Person> iterator() {
        return new ListIterator(this);
    }

    private class ListIterator implements Iterator<Person> {

        private SortedList node;

        public ListIterator(SortedList n) {
            node = n;
        }

        @Override
        public boolean hasNext() {
            if(node == null)
                return false;

            return !node.isEmpty();
        }

        @Override
        public Person next() {
            Person out = node.value;
            node = node.next;
            return out;
        }
    }
}
