/**
 * Created by Heraldo on 28.06.2015.
 */
public class Dog {
    private final String name;
    private final float height;
    private final float weight;
    private Person owner;

    public Dog(String name) {
        this.name = name;
        height = (float)Math.random() * 80f + 20f;
        weight = (float)Math.random() * 7f + 2f;
    }

    public Dog(String name, Person owner) {
        this(name);
        setOwner(owner);
    }

    public Dog(Dog other) { //tiefe Kopie
        this(other.name, other.height, other.weight);

        if(other.owner != null) {
            Person p = other.owner;
            this.owner = new Person(p.getName(), p.getHeight(), p.getWeight());
        }

        if(this.owner != null)
            this.owner.setPet(this);
    }

    public Dog(String n, float h, float w) { // Hilfskonstruktor fuer eine tiefe Kopie
        name = n;
        height = h;
        weight = w;
    }

    public String getName() {
        return name;
    }

    public float getHeight() {
        return height;
    }

    public float getWeight() {
        return weight;
    }

    public Person getOwner() {
        return owner;
    }

    public void setOwner(Person owner) { this.owner = owner; }

    @Override
    public String toString() {
        String out = owner != null? owner.getName() : "none";
        return String.format("Dog called %s, %.2f tall, %.2f heavy and owner %s.\n", name, height, weight, out);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;

        if (o instanceof Dog) {

            Dog dog = (Dog) o;
            boolean check = name.equals(dog.name) && height == dog.height && weight == dog.weight;

            if(owner != null)
                return checkOwners(dog.owner) && check;

            return dog.owner != null? false : check;
        }

        return false;
    }

    private boolean checkOwners(Person p) { // verhindert endlose Rekursion bzw. StackOverflow
        return owner.getName().equals(owner.getName()) && owner.getHeight() == p.getHeight()
                && owner.getWeight() == p.getWeight();
    }
}
