import java.util.Objects;

/**
 * Created by Heraldo on 28.06.2015.
 */
public class Dog extends Animal implements Comparable<Dog>, Pet{
    private Person owner;

    // Konstruktor 1
    public Dog(String name) {
        this(name, (float) Math.random() * 100f + 100f, (float) Math.random() * 60f + 20f); // ruft Hilfskonstruktor
    }

    // Konstruktor 2
    public Dog(String name, Person owner) {
        this(name); // ruft Konstruktor 1
        setOwner(owner);
    }

    // Kopierkonstruktor
    public Dog(Dog other) { //tiefe Kopie
        this(other.name, other.height, other.weight); // ruft Hilfskonstruktor

        if(other.owner != null) {
            Person p = other.owner;
            this.owner = new Person(p.getName(), p.getHeight(), p.getWeight());
        }

        if(this.owner != null)
            this.owner.setPet(this);
    }

    // Hilfskonstruktor fuer eine tiefe Kopie
    public Dog(String n, float h, float w) {
        super(n, h, w); // ruft Superkonstruktor
    }

    @Override
    public Person getOwner() {
        return owner;
    }

    @Override
    public void setOwner(Person owner) { this.owner = owner; }

    @Override
    public int compareTo(Dog p) {
        if(this.weight - p.weight == 0)
            return 0;

        return this.weight - p.weight < 0? -1 : 1;
    }

    @Override
    public String toString() {
        String out = owner != null? owner.getName() : "none";
        return String.format("Dog called %s, %.2f tall, %.2f heavy and owner %s.\n", name, height, weight, out);
    }

    @Override
    public Pet clone() {
        return new Dog(name, height, weight);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;

        if (o instanceof Dog) {

            Dog dog = (Dog) o;

            if(owner != null)
                return checkOwners(dog.owner) && super.equals(dog);

            return dog.owner != null? false : super.equals(dog);
        }

        return false;
    }

    private boolean checkOwners(Person p) { // verhindert endlose Rekursion bzw. StackOverflow
        return owner.getName().equals(owner.getName()) && owner.getHeight() == p.getHeight()
                && owner.getWeight() == p.getWeight();
    }
}
