/**
 * Created by Heraldo on 28.06.2015.
 */
public class Person extends Being implements Comparable<Person> {
    private Pet pet;

    // Konstruktor 1
    public Person(String name) {
        this(name, (float) Math.random() * 100f + 100f, (float) Math.random() * 60f + 20f); // ruft Hilfskonstruktor
    }

    // Konstruktor 2
    public Person(String name, Pet pet) {
        this(name); // ruft Konstruktor 1
        setPet(pet);
    }

    // Kopierkonstruktor
    public Person(Person other) { //tiefe Kopie
        this(other.name, other.height, other.weight); // ruft Hilfskonstruktor

        if(other.pet != null)
            this.pet = other.pet.clone();

        if(this.pet != null)
            this.pet.setOwner(this);
    }

    // Hilfskonstruktor fuer eine tiefe Kopie
    public Person(String n, float h, float w) {
        super(n, h, w); // ruft Superkonstruktor
    }

    public Pet getPet() {
        return pet;
    }

    public void setPet(Pet pet) { this.pet = pet;}

    @Override
    public int compareTo(Person p) {
        if(this.height - p.height == 0)
            return 0;

        return this.height - p.height < 0? -1 : 1;
    }

    @Override
    public void move() {
        System.out.printf("Person called %s is moving.\n", name);
    }

    @Override
    public String toString() {
        String out = pet != null? pet.getName() : "none";
        return String.format("Person called %s, %.2f tall, %.2f heavy and pet %s.\n", name, height, weight, out);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;

        if (o instanceof Person) {

            Person person = (Person) o;

            boolean check = name.equals(person.name) && height == person.height && weight == person.weight;

            if(pet != null)
                return checkPets(person.pet) && check;

            return person.pet != null? false : check;
        }

        return false;
    }

    private boolean checkPets(Pet p) { // verhindert endlose Rekursion bzw. StackOverflow
        return pet.getName().equals(pet.getName()) && pet.getHeight() == p.getHeight()
                && pet.getWeight() == p.getWeight();
    }

}
