import java.util.Iterator;

/**
 * Created by Heraldo on 28.06.2015.
 */
public class SortedList<A extends Comparable<A>> {
    private SortedList next;
    private A value;

    public SortedList(){}

    public boolean isEmpty() {
        return value == null;
    }

    public void add(A value) {
        if(isEmpty())
            this.value = value;
        else {
            if (this.value.compareTo(value) > 0) {
                A p = this.value;
                this.value = value;
                value = p;
            }

            if (this.next == null)
                this.next = new SortedList();

            this.next.add(value);
        }
    }

    public int size() {
        return this.next != null? this.next.size() + 1 : 1;
    }

    public A get(int index) {
        if(index == 0)
            return this.value;

        if(this.next != null)
            return (A) this.next.get(index - 1);

        return null;
    }

    public Iterator<A> iterator() {
        return new ListIterator(this);
    }

    private class ListIterator implements Iterator<A> {

        private SortedList node;

        private ListIterator(SortedList n) {
            node = n;
        }

        @Override
        public boolean hasNext() {
            if(node == null)
                return false;

            return !node.isEmpty();
        }

        @Override
        public A next() {
            A out = (A) node.value;
            node = node.next;
            return out;
        }
    }
}
